#ifndef ARME_H
#define ARME_H

#include "../Structures/Affichable.h"
#include "../Tirs/Tirs_Gest.h"

#define NB_MODELS 9
enum WeaponType { GUN, FUSIL, SHOTGUN, USIANE, SCATTER, BAROUDEUR, SULFATEUSE, TRIPHASEUR, BOMBER };

class Arme
{
/// Fonctions
    public:

        Arme( int degats, WeaponType model, Tirs_Gest* tirsGest, Uint32 freqShot );
        virtual ~Arme();

        WeaponType getModel();// Permet de prendre la bonne surface dans le sprite loader

        void gachette(Vec pos, Vec visee, bool allie);// Appelée par Perso, tire si la fréquence est respectée

    protected :

        virtual void tirer(Vec pos, Vec visee, bool allie) = 0;// Tire selon le modèle de l'arme

/// Attributs
    protected:

        int m_degats;
        WeaponType m_model;

        Tirs_Gest* m_tirsGest;

        Uint32 m_lastShot;
        const Uint32 m_freqShot;
};

#endif // ARME_H
