#include "ClavierCtrl.h"

ClavierCtrl::ClavierCtrl(InputAndJoy* input)
:HardCtrl(input)
{
    //ctor
}

ClavierCtrl::~ClavierCtrl()
{
    //dtor
}

void ClavierCtrl::update()
{
    /// Gestion des changements de clavier Linux/Windows
    #ifdef WIN32
        #define PKEY_A SDLK_q
        #define PKEY_Q SDLK_a
        #define PKEY_Z SDLK_w
    #else
        #define PKEY_A SDLK_a
        #define PKEY_Q SDLK_q
        #define PKEY_Z SDLK_z
    #endif

    /// Deplacement
    m_mvt.setVecteur(0.0f, 0.0f);
    if ( m_input->getTouche(PKEY_Z) ) m_mvt.setY(1.0f);
    if ( m_input->getTouche(PKEY_Q) ) m_mvt.setX(-1.0f);
    if ( m_input->getTouche(SDLK_s) ) m_mvt.setY(-1.0f);
    if ( m_input->getTouche(SDLK_d) ) m_mvt.setX(1.0f);
    m_mvt.normaliser();

    /// Visee
    m_visee.setVecteur( m_input->getX() - m_input->getWinHalfW(), m_input->getWinHalfH() - m_input->getY() );

    /// Tir
    m_tir[ L_HAND ] = m_input->getBoutonSouris(1); // 1 = clic gauche
    m_tir[ R_HAND ] = m_input->getBoutonSouris(3); // 0 = clic droit

    /// Recherche
    m_search[ L_HAND ] = m_input->getTouche(PKEY_A);
    m_search[ R_HAND ] = m_input->getTouche(SDLK_e);

    /// Craft
    m_craft = m_input->getTouche(SDLK_c);
}
