#ifndef JEU_H
#define JEU_H

#include <iostream>
#include <ctime>

#include "Control/ClavierCtrl.h"
#include "Control/JoyCtrl.h"

#include "Control/IA/Brute.h"

#include "Persos/Persos_Gest.h"
#include "Tirs/Tirs_Gest.h"
#include "Armes/Armes_Gest.h"
#include "Structures/SpriteLoader.h"
#include "Terrain/Terrain.h"


class Jeu
{
/// Fonctions - - -
    public:
        Jeu();
        ~Jeu();

        bool init();

        int mainLoop();

    protected:
        void afficher( const Perso* focus, SDL_Surface* support );

/// Attributs - - -
    protected:
        SDL_Surface* m_screen;
        SpriteLoader m_sprites;
        SDL_Surface* m_cursor;

        Terrain* m_terrain;

        InputAndJoy* m_input;

        Tirs_Gest* m_tirsGest;
        Armes_Gest* m_armGest;
        Persos_Gest* m_persosGest;

        SDL_Surface** m_support;
        Perso** m_persoFocus;
        Uint16 m_nbJoueurs;
        SDL_Rect m_scinde;

        Vec m_look;
};

#endif // JEU_H
