#ifndef SPRITELOADER_H_INCLUDED
#define SPRITELOADER_H_INCLUDED

#include <iostream>
#include <string>
#include <map>
#include <SDL.h>

class SpriteLoader
{
public:

    SpriteLoader();
    SpriteLoader(std::string folder);
    SpriteLoader(std::string folder, bool optiFormat);
    ~SpriteLoader();

    SDL_Surface* takeSprite(std::string nom);
    void destroySprite(std::string nom);
    void addSprite(std::string nom, SDL_Surface* sprite);
    void assignFolder(std::string folder);

private:

    std::string m_folder;
    std::map<std::string, SDL_Surface*>::iterator m_it;
    std::map<std::string, SDL_Surface*> m_paquet;
    bool m_optiFormat; // True par défaut

};

#endif // SPRITELOADER_H_INCLUDED
